native g_ArrayMapList();

#define prefix "[^3CSHNS.RU^1]"
new sv_airaccelerate, sv_gravity;

public VIP_ACCESS(id)
{
	new access[32];
	if(id > 0)
	{
		if( get_user_flags(id) & ADMIN_IMMUNITY )
			access = "Head Admin";

		if (get_user_flags(id) & ADMIN_LEVEL_E)
			access = "Honorary";

		if (get_user_flags(id) & ADMIN_LEVEL_H)
			access = "VIP LVL 3";

		if (get_user_flags(id) & ADMIN_LEVEL_G)
			access = "VIP LVL 2";

		if (get_user_flags(id) & ADMIN_LEVEL_F)
			access = "VIP LVL 1";

		if (get_user_flags(id) & ADMIN_USER)
			access = "User";
	}
	else
	{
		access = "Server";
	}

	return access;
}

stock StringTimer(const Float:flRealTime, szOutPut[], const iSizeOutPut)
{
    static Float:flTime, iMinutes, iSeconds, iMiliSeconds, Float:iMili;
    new string[12]

    flTime = flRealTime;

    if(flTime < 0.0) flTime = 0.0;

    iMinutes = floatround(flTime / 60, floatround_floor);
    iSeconds = floatround(flTime - (iMinutes * 60), floatround_floor);
    iMili = floatfract(flRealTime)
    formatex(string, 11, "%.02f", iMili >= 0 ? iMili + 0.005 : iMili - 0.005);
    iMiliSeconds = floatround(str_to_float(string) * 100, floatround_floor);

    formatex(szOutPut, iSizeOutPut, "%02d:%02d.%02d", iMinutes, iSeconds, iMiliSeconds);
}

stock kz_vector_add(const Float:in1[], const Float:in2[], Float:out[])
{
	out[0] = in1[0] + in2[0];
	out[1] = in1[1] + in2[1];
	out[2] = in1[2] + in2[2];
}

stock kz_vecotr_mul_scalar(const Float:vec[], Float:scalar, Float:out[])
{
	out[0] = vec[0] * scalar;
	out[1] = vec[1] * scalar;
	out[2] = vec[2] * scalar;
}