#define ACCESS_H ADMIN_LEVEL_E
#define ACCESS_3 ADMIN_LEVEL_H
#define ACCESS_2 ADMIN_LEVEL_G
#define ACCESS_1 ADMIN_LEVEL_F
#define ACCESS_0 ADMIN_USER

new Handle:g_SqlTuple

// MapID in kz_maps SQL Table
new kz_mapID
new kz_maptype[25]
new delete_entity

new MapName[64]
new weapon_name[33]
new Float:timer_time[33]
new Float:Update_timer[33]
// my time in top15
new Float:kz_my_protime[33]
new Float:kz_my_nubtime[33]
// Speclist
new SpecList[33] = { true, ... }
new SpecAdmImm[33]
// SQL Config
new InvisUser[33]
new InvisWater[33]
new full_Invisible[33]
new TP_MODE[33]
new noTeleport[32]
new ShowTime[33]
new SaveCfgDate[33][40]
enum
{
	TOP_NULL,
	PRO_TOP,
	NUB_TOP,
	STATS_TOP,
	WeaponTop,
	PROGEN,
	LAST_PRO10,
	PRO_RECORDS,
	PLAYERS_RANKING,
	GENERAL_RANKING,
	MAPS_STATISTIC,
	PL_STATS,
	WR_PLAY,
	HELP
}

new const g_weaponsnames[][] =
{
	"", // NULL
	"p228", "shield", "scout", "hegrenade", "xm1014", "c4",
	"mac10", "aug", "smokegrenade", "elite", "fiveseven",
	"ump45", "sg550", "galil", "famas", "usp", "glock18",
	"awp", "mp5navy", "m249", "m3", "m4a1", "tmp", "g3sg1",
	"flashbang", "deagle", "sg552", "ak47", "knife", "p90",
	"glock",  "elites", "fn57", "mp5", "vest", "vesthelm", 
	"flash", "hegren", "sgren", "defuser", "nvgs", "primammo", 
	"secammo", "km45", "9x19mm", "nighthawk", "228compact", 
	"12gauge", "autoshotgun", "mp", "c90", "cv47", "defender", 
	"clarion", "krieg552", "bullpup", "magnum", "d3au1", 
	"krieg550"
}

new const other_weapons_name[8][] =
{
	"weapon_p90", "weapon_famas", "weapon_sg552", "weapon_awp",
	"weapon_m4a1", "weapon_m249", "weapon_ak47", "weapon_awp"
}

enum _:SQL {
	SQL_TABLE,
	SQL_INSERT,
	SQL_MAP,
	SQL_MYTIME
};

enum _:CVARS {
	HOST[48],
	USER[32],
	PASS[32],
	DB[32]
};

new g_eCvars[CVARS];

public QueryHandle(iFailState, Handle:hQuery, szError[], iErrnum, cData[], iSize, Float:fQueueTime)
{
	if (iFailState != TQUERY_SUCCESS) {
		log_amx("SQL Error #%d - %s", iErrnum, szError);
		return;
	}

	switch(cData[0]) {
		case SQL_MAP: {
			if (SQL_NumResults(hQuery)) {
				new startposition[64], finishposition[64], p_start[3][64], p_finish[3][64];
				new mapid = SQL_FieldNameToNum(hQuery, "id")
				new type = SQL_FieldNameToNum(hQuery, "type")
				new delentity = SQL_FieldNameToNum(hQuery, "entity")
				new start = SQL_FieldNameToNum(hQuery, "start")
				new finish = SQL_FieldNameToNum(hQuery, "finish")

				kz_mapID = SQL_ReadResult(hQuery, mapid)
				SQL_ReadResult(hQuery, type, kz_maptype, charsmax(kz_maptype))
				delete_entity = SQL_ReadResult(hQuery, delentity)
				SQL_ReadResult(hQuery, start, startposition, charsmax(startposition))
				SQL_ReadResult(hQuery, finish, finishposition, charsmax(finishposition))

				if(!equali(startposition, ""))
				{
					strtok(startposition, p_start[0], charsmax(p_start[]), startposition, charsmax(startposition), ' ', true)
					strtok(startposition, p_start[1], charsmax(p_start[]), startposition, charsmax(startposition), ' ', true)
					strtok(startposition, p_start[2], charsmax(p_start[]), startposition, charsmax(startposition), ' ', true)
					DefaultStartPos[0] = str_to_float(p_start[0]);
					DefaultStartPos[1] = str_to_float(p_start[1]);
					DefaultStartPos[2] = str_to_float(p_start[2]);
					Default_SF[0] = true;
				}
				else
					Default_SF[0] = false;

				if(!equali(finishposition, ""))
				{
					strtok(finishposition, p_finish[0], charsmax(p_finish[]), finishposition, charsmax(finishposition), ' ', true)
					strtok(finishposition, p_finish[1], charsmax(p_finish[]), finishposition, charsmax(finishposition), ' ', true)
					strtok(finishposition, p_finish[2], charsmax(p_finish[]), finishposition, charsmax(finishposition), ' ', true)
					DefaultFinishPos[0] = str_to_float(p_finish[0]);
					DefaultFinishPos[1] = str_to_float(p_finish[1]);
					DefaultFinishPos[2] = str_to_float(p_finish[2]);
					Default_SF[1] = true;
				}
				else
					Default_SF[1] = false;

				//if(equali(kz_maptype, "axn")) mapIsAXN = true;
				if(equali(kz_maptype, "slide")) mapIsSlide = true;
				if(equali(kz_maptype, "gravity")) mapIsGravity = true;
				if(equali(kz_maptype, "")) kz_maptype = "n/a";

				if (delete_entity)
				{
					for(new i = 0; i < sizeof(g_remove_ent); i++)
						sx_remove_entity(g_remove_ent[i], "classname", 0, "")
				}

				if(!kz_mapID)
				{
					//SQL_Insert()
					server_print("[KZ_SQL] !kz_mapID")
				}

				server_print("[KZ_SQL] ID Map = %d", kz_mapID)
				server_print("[KZ_SQL] Type map = %s", kz_maptype)
			} else {
				server_print("[KZ_SQL] !SQL_NumResults")
				SQL_Insert()
			}
		}
		case SQL_MYTIME: {
			new id = cData[1]
			new type = cData[2]
			if(SQL_NumResults(hQuery))
			{
				if (type == PRO_TOP)
					SQL_ReadResult(hQuery, 5, kz_my_protime[id])
				else
					SQL_ReadResult(hQuery, 5, kz_my_nubtime[id])
			}
			else
			{
				if (type == PRO_TOP)
					kz_my_protime[id] = 0.0
				else
					kz_my_nubtime[id] = 0.0
			}
		}
	}
}

public SQL_Insert() {
	new szQuery[512];
	new cData[1]; cData[0] = SQL_INSERT;

	formatex(szQuery, charsmax(szQuery), "INSERT INTO `kz_maps` (mapname) VALUES ('%s')", MapName);
	server_print("[KZ_SQL] SQL_Insert")
	SQL_ThreadQuery(g_SqlTuple, "QueryHandle", szQuery, cData, sizeof(cData));
}

RegisterCvars() {
	new pCvar;
	pCvar = create_cvar("kz_host", "", FCVAR_PROTECTED, "Host");
	bind_pcvar_string(pCvar, g_eCvars[HOST], charsmax(g_eCvars[HOST]));

	pCvar = create_cvar("kz_user", "", FCVAR_PROTECTED, "User");
	bind_pcvar_string(pCvar, g_eCvars[USER], charsmax(g_eCvars[USER]));

	pCvar = create_cvar("kz_pass", "", FCVAR_PROTECTED, "Password");
	bind_pcvar_string(pCvar, g_eCvars[PASS], charsmax(g_eCvars[PASS]));

	pCvar = create_cvar("kz_db", "", FCVAR_PROTECTED, "DB");
	bind_pcvar_string(pCvar, g_eCvars[DB], charsmax(g_eCvars[DB]));
}


RegisterSQL() {
	g_SqlTuple = SQL_MakeDbTuple(g_eCvars[HOST], g_eCvars[USER], g_eCvars[PASS], g_eCvars[DB]);
	SQL_SetCharset(g_SqlTuple, "utf-8");

	new szQuery[1024], cData[1] = SQL_TABLE;

	formatex(szQuery, charsmax(szQuery), "CREATE TABLE IF NOT EXISTS `kz_savepos` (`map_id` INT(10) NOT NULL,`authid` VARCHAR(64) NOT NULL COLLATE 'utf8_general_ci',`time` DECIMAL(65,2) NOT NULL,`x` INT(15) NOT NULL,`y` INT(15) NOT NULL,`z` INT(15) NOT NULL,`x_vel` INT(15) NOT NULL,`y_vel` INT(15) NOT NULL,`z_vel` INT(15) NOT NULL,`weapon` INT(5) NOT NULL,`cp` DOUBLE(22,0) NOT NULL,`tp` DOUBLE(22,0) NOT NULL,`hp` INT(10) NOT NULL,`date` DATETIME NOT NULL)");
	SQL_ThreadQuery(g_SqlTuple, "QueryHandle", szQuery, cData, sizeof(cData));

	formatex(szQuery, charsmax(szQuery), "CREATE TABLE IF NOT EXISTS `kz_pro15` ( `map_id` INT(10) NOT NULL, `mapname` VARCHAR(64) NOT NULL COLLATE 'utf8_general_ci', `authid` VARCHAR(64) NOT NULL COLLATE 'utf8_general_ci', `country` varchar(6) NOT NULL, `name` VARCHAR(64) NOT NULL COLLATE 'utf8_general_ci', `time` DECIMAL(65,2) NOT NULL, `weapon` varchar(64) NOT NULL, `date` DATETIME NOT NULL)");
	SQL_ThreadQuery(g_SqlTuple, "QueryHandle", szQuery, cData, sizeof(cData));

	formatex(szQuery, charsmax(szQuery), "CREATE TABLE IF NOT EXISTS `kz_nub15` ( `map_id` INT(10) NOT NULL, `mapname` VARCHAR(64) NOT NULL COLLATE 'utf8_general_ci', `authid` VARCHAR(64) NOT NULL COLLATE 'utf8_general_ci', `country` varchar(6) NOT NULL, `name` VARCHAR(64) NOT NULL COLLATE 'utf8_general_ci', `time` DECIMAL(65,2) NOT NULL, `weapon` varchar(64) NOT NULL, `date` DATETIME NOT NULL,`checkpoints` DOUBLE(22,0) NOT NULL,`gocheck` DOUBLE(22,0) NOT NULL)");
	SQL_ThreadQuery(g_SqlTuple, "QueryHandle", szQuery, cData, sizeof(cData));

	formatex(szQuery, charsmax(szQuery), "CREATE TABLE IF NOT EXISTS `kz_maps` (`id` INT(11) NOT NULL AUTO_INCREMENT,`mapname` VARCHAR(64) NOT NULL COLLATE 'utf8_general_ci',`type` VARCHAR(64) NULL COLLATE 'utf8_general_ci',`challenge` INT(3) NOT NULL DEFAULT '0',`entity` INT(2) NOT NULL DEFAULT '1',`start` VARCHAR(50) NULL COLLATE 'utf8_general_ci',`finish` VARCHAR(50) NULL COLLATE 'utf8_general_ci',PRIMARY KEY (`id`))");
	SQL_ThreadQuery(g_SqlTuple, "QueryHandle", szQuery, cData, sizeof(cData));
}

public SQL_Map() {
	new szQuery[512];
	new cData[1]; cData[0] = SQL_MAP;

	formatex(szQuery, charsmax(szQuery), "\
		SELECT * \
		FROM `kz_maps` \
		WHERE `mapname` = '%s'", MapName);
	SQL_ThreadQuery(g_SqlTuple, "QueryHandle", szQuery, cData, sizeof(cData));
}

public SQL_StartFinish(bool:L, Float:position[3])
{
	if(L) Default_SF[0] = true;
	else Default_SF[1] = true;

	new szQuery[1024]
	formatex(szQuery, charsmax(szQuery), "\
	UPDATE `kz_maps` \
	SET `%s` = '%f %f %f' \
	WHERE (`id` = '%d')", (L ? "start" : "finish"), position[0], position[1], position[2], kz_mapID)
	SQL_ThreadQuery(g_SqlTuple, "QueryHandle", szQuery)
}

public SQL_StatsAdd(iFailState, Handle:hQuery, szError[], iErrnum, cData[], iSize, Float:fQueueTime)
{
	new id = cData[0]
	new style = cData[1]
	new Float:time = Update_timer[id];
	new check = cData[3]
	new gocheck = cData[4]
	if( iFailState != TQUERY_SUCCESS )
	{
		log_amx("[KZ] TOP15 SQL: SQL Error #%d - %s", iErrnum, szError)
		client_print_color(0, print_team_blue,  "%s^1 %F", prefix, LANG_PLAYER, "KZ_TOP15_SQL_ERROR")
	}
	new checkpoints[32], gochecks[32]
	new szQuery[1024]
	new name[32], recdata[64], country[3], ip[15]
	get_user_name(id, name, 31)
	get_user_ip (id, ip, sizeof ip - 1, 1)
	geoip_code2_ex(ip, country)
	get_time("%Y%m%d%H%M%S", recdata, sizeof recdata - 1)
	new wpn = get_user_weapon( id )
	replace_all(name, 31, "'", "")

	new weapon = get_user_weapon(id)
	get_weaponname(weapon, weapon_name, charsmax(weapon_name))


	if (SQL_NumResults(hQuery) == 0)
	{
		formatex(checkpoints, 31, ", '%d'", check)
		formatex(gochecks, 31, ", '%d'", gocheck)

		formatex( szQuery, charsmax(szQuery), "INSERT INTO `%s` VALUES ('%d', '%s', '%s', '%s', '%s', '%f', '%s', '%s'%s%s)", style == PRO_TOP ? "kz_pro15" : "kz_nub15", kz_mapID, MapName, kz_authid[id], country, name, time, g_weaponsnames[wpn], recdata, style == PRO_TOP ? "" : checkpoints, style == PRO_TOP ? "" : gochecks);
		SQL_ThreadQuery(g_SqlTuple, "QueryHandle", szQuery )
		GetNewRank(id, style, false)
	}
	else
	{
		new Float:oldtime, Float:thetime
		SQL_ReadResult(hQuery, 0, oldtime)

		if(time < oldtime)
		{
			formatex(checkpoints, 31, ", checkpoints='%d'", check)
			formatex(gochecks, 31, ", gocheck='%d'", gocheck)
			thetime = oldtime - time

			show_finish_message(id, thetime, false, true) // Сообщение, если рекорд поставлен и время на сколько быстрее.

			formatex(szQuery, charsmax(szQuery), "UPDATE `%s` SET time='%f', date='%s' %s%s WHERE map_id='%d' AND authid='%s'", style == PRO_TOP ? "kz_pro15" : "kz_nub15", time, recdata, style == PRO_TOP ? "" : checkpoints, style == PRO_TOP ? "" : gochecks, kz_mapID, kz_authid[id])
			SQL_ThreadQuery(g_SqlTuple, "QueryHandle", szQuery )
			GetNewRank(id, style, false)
		}
		else
		{
			thetime = time - oldtime
			show_finish_message(id, thetime, false, false) // Сообщение, если новый рекорд не поставлен
		}
	}

	return PLUGIN_HANDLED
}

stock GetNewRank(id, type, bool:user_weapon)
{
	new szQuery[1024];

	new cData[2]
	cData[0] = id
	cData[1] = type
	new wpn = get_user_weapon( id )

	if (user_weapon)
		formatex(szQuery, charsmax(szQuery), "SELECT authid FROM `%s` WHERE map_id='%d' AND weapon='%s' ORDER BY time", type == PRO_TOP ? "kz_pro15" : "kz_nub15", kz_mapID, g_weaponsnames[wpn])
	else
		formatex(szQuery, charsmax(szQuery), "SELECT authid FROM `%s` WHERE map_id='%d' ORDER BY time", type == PRO_TOP ? "kz_pro15" : "kz_nub15", kz_mapID)

	SQL_ThreadQuery(g_SqlTuple, "GetNewRank_QueryHandler", szQuery, cData, sizeof(cData))
}

public GetNewRank_QueryHandler(iFailState, Handle:hQuery, szError[], iErrnum, cData[], iSize, Float:fQueueTime)
{
	new id = cData[0]
	if( iFailState != TQUERY_SUCCESS )
	{
		return log_amx("TOP15 SQL: SQL Error #%d - %s", iErrnum, szError)
	}

	new authid[32], namez[32], i = 0
	get_user_name(id, namez, 31)

	new bool:user_weapon = false;
	new weapon = get_user_weapon(id)
	get_weaponname(weapon, weapon_name, charsmax(weapon_name))

	for(new i = 0; i < 8; i++)
	{
		if(equali(other_weapons_name[i], weapon_name))
		{
			user_weapon = true;
		}
	}

	while( SQL_MoreResults(hQuery) )
	{
		i++
		SQL_ReadResult(hQuery, 0, authid, 31)
		if( equal(authid, kz_authid[id]) )
		{
			if (user_weapon)
				client_print_color(0, print_team_red,  "^4%s^3 %s^4 is now ^3%d^4 in^3 %s^4",prefix, namez, i, cData[1] == PRO_TOP ? "Professional Weapon Top" : "General Weapon Top");
			else
				client_print_color(0, print_team_red,  "^4%s^3 %s^4 is now ^3%d^4 in^3 %s^4",prefix, namez, i, cData[1] == PRO_TOP ? "Professional Top" : "General Top");

			if( i == 1)
			{
				if (user_weapon) {
					//emit_sound(0, CHAN_VOICE, "kzvc.wav", VOL_NORM, ATTN_NORM, 0, PITCH_NORM)

				} else {
					if (cData[1] == PRO_TOP && !Savepos_activated[id])
						ClCmd_UpdateReplay(id, Update_timer[id])
				}
			}
			break;
		}
		SQL_NextRow(hQuery)
	}

	return PLUGIN_CONTINUE
}

public mytime(id, type)
{
	new szQuery[1024], cData[3];
	cData[0] = SQL_MYTIME;
	cData[1] = id;
	cData[2] = type;
	formatex(szQuery, charsmax(szQuery), "\
	SELECT * \
	FROM `%s`\
	WHERE `map_id` = '%d' AND `authid` = '%s';", type == PRO_TOP ? "kz_pro15" : "kz_nub15", kz_mapID, kz_authid[id]);
	SQL_ThreadQuery(g_SqlTuple, "QueryHandle", szQuery, cData, sizeof(cData));
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SQL CFG ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public SQL_WorkHandle(failstate, Handle:hQuery, error[], errcode, cData[], iSize, Float:fQueueTime)
{
	if( failstate == TQUERY_CONNECT_FAILED )
	{
		set_fail_state("Could not connect to database.");
	}
	else if( failstate == TQUERY_QUERY_FAILED )
	{
		set_fail_state("Query failed.");
	}
	else if( errcode )
	{
		log_amx("Error on query: %s", error);
	}
	else
	{
		// Nice SQL !!!
	}
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ SAVE POSITION ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

public SQL_Check_Savepos(id)
{
	Savepos_have[id] = true;
	new szQuery[512], cData[1]
	cData[0] = id
	formatex(szQuery, charsmax(szQuery), "SELECT * FROM `kz_savepos` WHERE map_id='%d' AND authid='%s'", kz_mapID, kz_authid[id])
	SQL_ThreadQuery(g_SqlTuple, "SQL_SaveposHandle", szQuery, cData, sizeof(cData))
}

public SQL_SaveposHandle(failstate, Handle:hQuery, error[], errcode, cData[], iSize, Float:fQueueTime)
{
	new id = cData[0]

	if( failstate == TQUERY_CONNECT_FAILED )
	{
		set_fail_state("Could not connect to database.");
	}
	else if( failstate == TQUERY_QUERY_FAILED )
	{
		set_fail_state("Query failed.");
	}
	else if( errcode )
	{
		log_amx("Error on query: %s", error);
	}
	else
	{
		if(SQL_NumResults(hQuery))
		{
			SQL_ReadResult(hQuery, 2, SavedTime[id])
			SavedWeapon[id] = SQL_ReadResult(hQuery, 9)
			SavedChecks[id] = SQL_ReadResult(hQuery, 10)
			SavedGoChecks[id] = SQL_ReadResult(hQuery, 11)
			SavedHp[id] = SQL_ReadResult(hQuery, 12)
			// Координаты в трехмерной плоскости
			SavedOrigins[id][0] = SQL_ReadResult(hQuery, 3)
			SavedOrigins[id][1] = SQL_ReadResult(hQuery, 4)
			SavedOrigins[id][2] = SQL_ReadResult(hQuery, 5)
			SavedVelocity[id][0] = SQL_ReadResult(hQuery, 6)
			SavedVelocity[id][1] = SQL_ReadResult(hQuery, 7)
			SavedVelocity[id][2] = SQL_ReadResult(hQuery, 8)
			SQL_ReadResult(hQuery, 13, SavedDate[id], charsmax(SavedDate))

			StringTimer(SavedTime[id], SavedTimeConvert[id], sizeof(SavedTimeConvert) - 1);
			Savepos_have[id] = true;

			SQL_Savepos_menu(id)
		}
		else
		{
			Savepos_have[id] = false;
		}
	}
}

public SQL_Savepos(id)
{
	if( !is_user_alive(id) || !timer_started[id] || is_user_bot(id) )	return PLUGIN_HANDLED;

	if(get_user_noclip(id))
		Pause(id)

	new entclassname[33];
	pev(pev(id, pev_groundentity), pev_classname, entclassname, 32);

	if(equal(entclassname, "func_door")) return PLUGIN_HANDLED

	//if( !( pev( id, pev_flags ) & FL_ONGROUND ))

	new Float:Time,check,gocheck
	new save_data[64], szQuery[512]

	new Float:origin[3], Float:velocity[3]
	pev(id, pev_origin, origin)
	pev(id, pev_velocity, velocity)

	if(IsPaused[id])
	{
		Time = g_pausetime[id]
		Pause(id)
	}
	else
		Time=get_gametime() - timer_time[id]

	if(Time < 60.0) return PLUGIN_HANDLED;

	check=checknumbers[id]
	gocheck=gochecknumbers[id]
	new wpn = get_user_weapon( id )
	new hp = get_user_health(id)
	get_time("%Y%m%d%H%M%S", save_data, sizeof save_data - 1)

	formatex(szQuery, charsmax(szQuery), "REPLACE INTO `kz_savepos` (`map_id`, `authid`, `time`, `x`, `y`, `z`, x_vel, y_vel, z_vel, `weapon`, `cp`, `tp`, `hp`, `date`) VALUES ('%d', '%s', '%f', '%d', '%d', '%d', '%d', '%d', '%d', '%s', '%d', '%d', '%d', '%s');", kz_mapID, kz_authid[id], Time, origin[0], origin[1], origin[2], velocity[0], velocity[1], velocity[2], g_weaponsnames[wpn], check, gocheck, hp, save_data)
	SQL_ThreadQuery(g_SqlTuple, "SQL_WorkHandle", szQuery)

	reset_checkpoints(id)
	Savepos_have[id] = true; //

	return PLUGIN_HANDLED
}

public SQL_Savepos_menu(id)
{
	if(!is_user_connected(id) || !is_user_alive(id)) return PLUGIN_HANDLED

	new title[256], g_HP[51]

	if (SavedHp[id] > 100) 	{
		formatex(g_HP, charsmax(g_HP), "\rGodmode\w"); // Если больше 100 хп, то godmode
	} else if (SavedHp[id] > 80) {
		formatex(g_HP, charsmax(g_HP), "\w%d", SavedHp[id]); // Если больше 80 хп, подсветка белым
	} else if (SavedHp[id] > 30 && SavedHp[id] < 80) {
		formatex(g_HP, charsmax(g_HP), "\y%d\w", SavedHp[id]); // Если больше 30 и меньше 80, то желтым
	} else {
		formatex(g_HP, charsmax(g_HP), "\r%d\w", SavedHp[id]); // Все остальное красным (мало хп)
	}


	formatex(title, charsmax(title), "\dSave position Menu^n^n\w[TIME] = %s^n[WPN] = %s^n[CP/TP] = %d/%d^n[HP] = %s^n[DATE] = %s", SavedTimeConvert[id], g_weaponsnames[SavedWeapon[id]], SavedChecks[id],SavedGoChecks[id],g_HP, SavedDate[id])
	new menu = menu_create(title, "SQL_Savepos_Handler")

	menu_additem( menu, "\yLOAD TIMER\w^n", "1" )
	menu_additem( menu, "\rDELETE\w old run and start new", "2" )
	menu_setprop(menu, MPROP_EXIT,MEXIT_NEVER)
	menu_display(id, menu, 0)

	return PLUGIN_HANDLED
}

public SQL_Savepos_Handler(id, menu, item)
{
	new szQuery[512]

	switch(item)
	{
		case 0:
		{
			reset_checkpoints(id)
			SQL_Teleport_to_Savepos(id)
		}
		case 1:
		{
			goStart(id)
			formatex(szQuery, charsmax(szQuery), "DELETE FROM kz_savepos WHERE map_id='%d' AND authid='%s'", kz_mapID, kz_authid[id])
			SQL_ThreadQuery(g_SqlTuple, "SQL_WorkHandle", szQuery)
			Savepos_have[id] = false; // Savepos нету, таймер будет нажиматся.
		}
	}
	return PLUGIN_HANDLED
}

public SQL_Teleport_to_Savepos(id)
{
	if( !is_user_alive(id) )
		return PLUGIN_HANDLED;

	new szQuery[512], origin[3], velocity[3]

	if(mapIsSlide || g_bHealsOnMap) {
		GodModeOn[id] = true
	} else {
		GodModeOn[id] = false
	}

	// Hook and Noclip off
	set_user_noclip(id, 0)
	remove_hook(id)

	origin[0] = SavedOrigins[id][0]
	origin[1] = SavedOrigins[id][1]
	origin[2] = SavedOrigins[id][2]
	velocity[0] = SavedVelocity[id][0]
	velocity[1] = SavedVelocity[id][1]
	velocity[2] = SavedVelocity[id][2]
	// Телепорт к координатам
	set_pev(id, pev_velocity, Float:{0.0, 0.0, 0.0})
	set_pev(id, pev_flags, pev(id, pev_flags) | FL_DUCKING )
	set_pev(id, pev_origin, origin)
	set_pev(id, pev_velocity, velocity)

	for (new i = 0; i < 10; i++)
	{
		CheckPoint(id)
	}
	// CheckPoints & GoChecks
	checknumbers[id]=SavedChecks[id]
	gochecknumbers[id]=SavedGoChecks[id]
	// Устанавливаем значение ХП
	set_user_health(id, SavedHp[id])
	// Weapons
	strip_user_weapons(id)
	give_item(id, g_weaponsnames[SavedWeapon[id]])
	
	// Timer
	timer_time[id]=get_gametime()-SavedTime[id]
	timer_started[id]=true
	Pause(id)
	// Delete Line in database
	formatex(szQuery, charsmax(szQuery), "DELETE FROM kz_savepos WHERE map_id='%d' AND authid='%s'", kz_mapID, kz_authid[id])
	SQL_ThreadQuery(g_SqlTuple, "SQL_WorkHandle", szQuery)
	Savepos_activated[id] = true; // REC бот не будет засчитан.
	Savepos_have[id] = false; // Savepos нету, таймер будет нажиматся.
	Savepos_exploit[id] = true;

	return PLUGIN_HANDLED
}
